@0xc7941adf5db6bbf0;

using Rust = import "programming_language/rust.capnp";
$Rust.parentModule("schema");

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using General = import "general.capnp";
using Space = import "space.capnp".Space;
using Role = import "role.capnp".Role;

struct User
{
    id @0 :General.UUID;
    username @1 :Text;
    space @2 :Space;

    struct UserInfoExtended
    {
        id @0 :General.UUID;
        firstname @1 :Text;
        lastname @2 :Text;
        address @3 :Address;

        struct Address
        { # TODO POST*CODE
            text @0 :Text;
        }
    }

    info @3 :Info;
    interface Info $CSharp.name("InfoInterface") {
        getUserInfoExtended @0 () -> ( userInfoExtended :UserInfoExtended );
    }

    manage @4 :Manage;
    interface Manage $CSharp.name("ManageInterface") {
        pwd @0 ( pwd :Text ) -> ();
    }

    admin @5 :Admin;
    interface Admin $CSharp.name("AdminInterface") {
        addRole @0 ( role :Role ) -> ();
        removeRole @1 ( role :Role ) -> ();
    }

    cardDESFireEV2 @6 :CardDESFireEV2;
    interface CardDESFireEV2 $CSharp.name("CardDESFireInterface") {
        getPIDList @0 () -> ( pids :List(Text) );
        
        getVersion @1 () -> ( version :Text );
        getDomain @2 () -> ( Domain :Text );
        getPID @3 () -> ( pid :Text );
        
        bind @4 ( pid :Text, auth_key :Text ) -> ();
        revoke @5 ( pid :Text ) -> ();
    }
}